/*************************************************************
obj.h -- http://home.scarlet.be/zoetrope
Copyright (C) 2007  SFJOIBSUTUFZBFSU

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.
*************************************************************/
#ifndef _OBJ_H_
#define _OBJ_H_

#include <stdio.h>

/*
 * Node types. See struct obj_model->first_node.
 */
#define OBJ_NODE_F			1
#define OBJ_NODE_USEMTL		2

/*
 * Error numbers.
 */
#define OBJ_EFOPEN		1
#define OBJ_EBADV		2
#define OBJ_EBADVT		3
#define OBJ_EBADVN		4
#define OBJ_EBADF		5
#define OBJ_EBADNEWMTL	6
#define OBJ_EBADKA		7
#define OBJ_EBADKD		8
#define OBJ_EBADKS		9
#define OBJ_ENSRANGE	10
#define OBJ_EBADNS		11
#define OBJ_EBADMAPKD	12
#define OBJ_ENONEWMTL	13
#define OBJ_EBADUSEMTL	14
#define OBJ_EBADMTLLIB	15
#define OBJ_ENOUSEMTL	16

struct obj_v {
	float x, y, z;
};

struct obj_vt {
	float u, v;
};

struct obj_vn {
	float x, y, z;
};

struct obj_node {
	unsigned char id;
	void *data;
	struct obj_node *next;
};

struct obj_f {
	int *v, *vt, *vn;
	int n;
};

struct obj_mtl {
	char *name;
	float Ka[3];
	float Kd[3];
	float Ks[3];
	float Ns;
	char *map_Kd;
	unsigned int map_Kd_id;
	struct obj_mtl *next;
};

struct obj_model {
	struct obj_v *v;
	int nv;
	struct obj_vt *vt;
	int nvt;
	struct obj_vn *vn;
	int nvn;
	struct obj_node *first_node;
	struct obj_mtl *first_mtl;
};

struct obj_err {
	char filename[FILENAME_MAX+1];
	int nerr;
	int nline;
};

extern struct obj_err obj_error;	/* defined in obj.c */

struct obj_model *load_obj_model(struct obj_model *m, const char *filename);
void free_obj_model(struct obj_model *m);
void obj_perror(const char *s);
void get_obj_bounding_box(const struct obj_model *m, float *minmax);

#endif

